# Class Record

java.lang.Object
java.lang.Record

public abstract class Record extends Object
This is the common base class of all Java language record classes.

More information about records, including descriptions of the implicitly declared methods synthesized by the compiler, can be found in section 8.10 of The Java Language Specification.

A record class is a shallowly immutable, transparent carrier for a fixed set of values, called the record components. The Java language provides concise syntax for declaring record classes, whereby the record components are declared in the record header. The list of record components declared in the record header form the record descriptor.

A record class has the following mandated members: a canonical constructor, which must provide at least as much access as the record class and whose descriptor is the same as the record descriptor; a private final field corresponding to each component, whose name and type are the same as that of the component; a public accessor method corresponding to each component, whose name and return type are the same as that of the component. If not explicitly declared in the body of the record, implicit implementations for these members are provided.

The implicit declaration of the canonical constructor has the same accessibility as the record class and initializes the component fields from the corresponding constructor arguments. The implicit declaration of the accessor methods returns the value of the corresponding component field. The implicit declaration of the `Object.equals(Object)`, `Object.hashCode()`, and `Object.toString()` methods are derived from all of the component fields.

The primary reasons to provide an explicit declaration for the canonical constructor or accessor methods are to validate constructor arguments, perform defensive copies on mutable components, or normalize groups of components (such as reducing a rational number to lowest terms.)

For all record classes, the following invariant must hold: if a record R's components are `c1, c2, ... cn`, then if a record instance is copied as follows:

        R copy = new R(r.c1(), r.c2(), ..., r.cn());

then it must be the case that `r.equals(copy)`.

API Note:
  A record class that `implements` `Serializable` is said to be a serializable record. Serializable records are serialized and deserialized differently than ordinary serializable objects. During deserialization the record's canonical constructor is invoked to construct the record object. Certain serialization-related methods, such as readObject and writeObject, are ignored for serializable records. More information about serializable records can be found in the Java Object Serialization Specification, Section 1.13, "Serialization of Records"., A record class structure can be obtained at runtime via reflection. See `Class.isRecord()` and `Class.getRecordComponents()` for more details.
See Java Language Specification:
  8.10 Record Classes
Since:
  16
External Specifications
  - Java Object Serialization Specification

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `Record()`
  Constructor for record classes to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `abstract int`
  `hashCode()`
  Returns a hash code value for the record.
  `abstract String`
  `toString()`
  Returns a string representation of the record.

  ### Methods declared in class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### Record

    protected Record()
    Constructor for record classes to call.

- ## Method Details

  - ### equals

    public abstract boolean equals(Object obj)
    Indicates whether some other object is "equal to" this one. In addition to the general contract of `Object.equals`, record classes must further obey the invariant that when a record instance is "copied" by passing the result of the record component accessor methods to the canonical constructor, as follows:

            R copy = new R(r.c1(), r.c2(), ..., r.cn());

    then it must be the case that `r.equals(copy)`.
    Overrides:
      `equals` in class `Object`
    Implementation Requirements:
      The implicitly provided implementation returns `true` if and only if the argument is an instance of the same record class as this record, and each component of this record is equal to the corresponding component of the argument; otherwise, `false` is returned. Equality of a component `c` is determined as follows:
      - If the component is of a reference type, the component is considered equal if and only if `Objects.equals(this.c, r.c)` would return `true`.
      - If the component is of a primitive type, using the corresponding primitive wrapper class `PW` (the corresponding wrapper class for `int` is `java.lang.Integer`, and so on), the component is considered equal if and only if `PW.compare(this.c, r.c)` would return `0`.
      Note that these rules imply that representation equivalence is used for the equality comparison of both primitive floating-point values and wrapped floating-point values.

      Apart from the semantics described above, the precise algorithm used in the implicitly provided implementation is unspecified and is subject to change. The implementation may or may not use calls to the particular methods listed, and may or may not perform comparisons in the order of component declaration.

    Parameters:
      `obj` - the reference object with which to compare.
    Returns:
      `true` if this record is equal to the argument; `false` otherwise.
    See Also:
      - `Objects.equals(Object,Object)`

  - ### hashCode

    public abstract int hashCode()
    Returns a hash code value for the record. Obeys the general contract of `Object.hashCode`. For records, hashing behavior is constrained by the refined contract of `Record.equals`, so that any two records created from the same components must have the same hash code.
    Overrides:
      `hashCode` in class `Object`
    Implementation Requirements:
      The implicitly provided implementation returns a hash code value derived by combining appropriate hashes from each component. The precise algorithm used in the implicitly provided implementation is unspecified and is subject to change within the above limits. The resulting integer need not remain consistent from one execution of an application to another execution of the same application, even if the hashes of the component values were to remain consistent in this way. Also, a component of primitive type may contribute its bits to the hash code differently than the `hashCode` of its primitive wrapper class.
    Returns:
      a hash code value for this record.
    See Also:
      - `Object.hashCode()`

  - ### toString

    public abstract String toString()
    Returns a string representation of the record. In accordance with the general contract of `Object.toString()`, the `toString` method returns a string that "textually represents" this record. The result should be a concise but informative representation that is easy for a person to read.

    In addition to this general contract, record classes must further participate in the invariant that any two records which are equal must produce equal strings. This invariant is necessarily relaxed in the rare case where corresponding equal component values might fail to produce equal strings for themselves.

    Overrides:
      `toString` in class `Object`
    Implementation Requirements:
      The implicitly provided implementation returns a string which contains the name of the record class, the names of components of the record, and string representations of component values, so as to fulfill the contract of this method. The precise format produced by this implicitly provided implementation is subject to change, so the present syntax should not be parsed by applications to recover record component values.
    Returns:
      a string representation of the object.
    See Also:
      - `Object.toString()`